% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/blocks.R
\name{ResBlock}
\alias{ResBlock}
\title{ResBlock}
\usage{
ResBlock(
  expansion,
  ni,
  nf,
  stride = 1,
  groups = 1,
  reduction = NULL,
  nh1 = NULL,
  nh2 = NULL,
  dw = FALSE,
  g2 = 1,
  sa = FALSE,
  sym = FALSE,
  norm_type = 1,
  act_cls = nn$ReLU,
  ndim = 2,
  ks = 3,
  pool = AvgPool(),
  pool_first = TRUE,
  padding = NULL,
  bias = NULL,
  bn_1st = TRUE,
  transpose = FALSE,
  init = "auto",
  xtra = NULL,
  bias_std = 0.01,
  dilation = 1,
  padding_mode = "zeros"
)
}
\arguments{
\item{expansion}{decoder}

\item{ni}{number of linear inputs}

\item{nf}{number of features}

\item{stride}{stride number}

\item{groups}{groups number}

\item{reduction}{reduction}

\item{nh1}{out channels 1}

\item{nh2}{out channels 2}

\item{dw}{dw paramer}

\item{g2}{g2 block}

\item{sa}{sa parameter}

\item{sym}{symmetric}

\item{norm_type}{normalization type}

\item{act_cls}{activation}

\item{ndim}{dimension number}

\item{ks}{kernel size}

\item{pool}{pooling type, Average, Max}

\item{pool_first}{pooling first}

\item{padding}{padding}

\item{bias}{bias}

\item{bn_1st}{batch normalization 1st}

\item{transpose}{transpose}

\item{init}{initializer}

\item{xtra}{xtra}

\item{bias_std}{bias standard deviation}

\item{dilation}{dilation number}

\item{padding_mode}{padding mode}
}
\value{
Block object
}
\description{
Resnet block from `ni` to `nh` with `stride`
}
